org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class GroupCountStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep<S,Map<E,Long>>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.GroupCountStep<S,E>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Map<E,Long>>>, Step<S,Map<E,Long>>, Barrier<Map<E,Long>>, ByModulating, Generating<Map<E,Long>,Map<E,Long>>, MemoryComputing<Map<E,Long>>, TraversalParent

      public class GroupCountStep<S,E>
      extends ReducingBarrierStep<S,Map<E,Long>>
      implements TraversalParent, ByModulating

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `GroupCountStep.GroupCountBiOperator<E>`

    - ### Nested classes/interfaces inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep

      `ReducingBarrierStep.NonEmittingSeed`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep

      `hasProcessedOnce, NON_EMITTING_SEED, reducingBiOperator, seedSupplier`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GroupCountStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLocalChild(Traversal.Admin<?,?> groupTraversal)`
    `GroupCountStep<S,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `List<Traversal.Admin<S,E>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `modulateBy(Traversal.Admin<?,?> keyTraversal)`
    `Map<E,Long>` | `projectTraverser(Traverser.Admin<S> traverser)`
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep

      `addBarrier, done, generateSeedFromStarts, getBiOperator, getMemoryComputeKey, getSeedSupplier, hasNextBarrier, nextBarrier, processAllStarts, processNextStart, reset, setReducingBiOperator, setSeedSupplier`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Generating

      `generateFinalResult`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### GroupCountStep

          public GroupCountStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### projectTraverser

          public Map<E,Long> projectTraverser(Traverser.Admin<S> traverser)

      Specified by:
        `projectTraverser` in class `ReducingBarrierStep<S,Map<E,Long>>`

    - #### addLocalChild

          public void addLocalChild(Traversal.Admin<?,?> groupTraversal)

      Specified by:
        `addLocalChild` in interface `TraversalParent`

    - #### getLocalChildren

          public List<Traversal.Admin<S,E>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Map<E,Long>>`
      Returns:
        the set of requirements

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> keyTraversal)
                          throws UnsupportedOperationException

      Specified by:
        `modulateBy` in interface `ByModulating`
      Throws:
        `UnsupportedOperationException`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### clone

          public GroupCountStep<S,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Map<E,Long>>`
      Overrides:
        `clone` in class `ReducingBarrierStep<S,Map<E,Long>>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Map<E,Long>>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Map<E,Long>>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Map<E,Long>>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Map<E,Long>>`

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.